/* -------------------------------------------------------------

   The KDE Dictionary Client

   (C) by Matthias Hlzer 1998

   Generated with the KDE Application Generator

   This file is distributed under the Artistic License.
   See LICENSE for details.

 ------------------------------------------------------------- */
 
 
 #ifndef _DICT_H_
#define _DICT_H_


#include <kapp.h>
#include <kprocess.h>
#include <qstrlist.h>
#include <qdialog.h>
#include <qlineedit.h>


class DictDialog;


class DictClient : public QObject
{
  Q_OBJECT
 
  friend DictDialog;
   
public:
  
  DictClient();
  ~DictClient();
  
  QStrList &dataBases() { return _databases; };
  QStrList &strategies() { return _strategies; };

  int getDatabase() { return database; };
  int getStrategy() { return strategy; };
  QString &getServer() { return server; };
      
  void processCommand(QString com1, QString com2="");
  QString &result() { return _result; };
  QString &error() { return _error; };
  

  bool running() { return _running; };

public slots:

  void updateServer();

  void setDatabase(int db);
  void setStrategy(int str);
    
signals:

  void commandExecuted();
  void infoUpToDate();
  
private slots:

  void exited(KProcess *proc);
  void stdOut(KProcess *proc, char *buffer, int buflen);
  void stdErr(KProcess *proc, char *buffer, int buflen);

  void processServerInfo();

protected:

  QString server;
  int     port;
  QString user;
  QString secret;
  QString commandName;
     
  unsigned int database, strategy;  
  
private:

  QStrList _databases, _strategies;
  QString _result, _error;


  KProcess *process;
  bool _running;  
};


class DictDialog : public QDialog
{
  Q_OBJECT
  
public:

  DictDialog(DictClient &client, QWidget *parent=0, const char *name=0);

private slots:

  void okPressed();
  
private:
 
  QLineEdit *server, *port, *user, *secret, *command;

  DictClient &_client;
    
};


#endif