/* -------------------------------------------------------------

   toplevel.h (part of The KDE Dictionary Client)

   (C) by Matthias Hlzer

   Generated with the KDE Application Generator

   This file is distributed under the Artistic License.
   See LICENSE for details.

 ------------------------------------------------------------- */


#ifndef _TOPLEVEL_H_
#define _TOPLEVEL_H_

#include <kapp.h>
#include <ktmainwindow.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <ktoolbar.h>
#include <qpopmenu.h>
#include <qaccel.h>
#include <htmlview.h>
#include <kledlamp.h>


#include "dict.h"


class TopLevel : public KTMainWindow
{
  Q_OBJECT
  
public:

  TopLevel();
  ~TopLevel();

  void lookup(QString query);
    
protected:

  void setupMenuBar();
  void setupStatusBar();
  void setupToolBar();

  void timerEvent(QTimerEvent *event);
  
private slots:

  void aboutApp();
  void returnPressed();
  
  void showDatabases();
  void showStrategies();
  void showServerInfo();
  
  void showVersion();
  void showLicense();
 
  void doLookup();
  
  void showResult();
    
  void updateServer();  
    
  void fillCombos();

  void serverDialog();

  void updateStatusBar();

  void selectAll();
  void copySelection();
  void updateMenu();
      
private:

  KHTMLView *htmlView;

  QPopupMenu *fileMenu, *optionsMenu, *helpMenu, *editMenu;
  int contentsID, aboutID, aboutKDEID, quitID;
  KLedLamp *led;
    
  DictClient client;
};

#endif
